]> git.ipfire.org Git - thirdparty/git.git/blame - git-am.sh
Import wildmatch from rsync
[thirdparty/git.git] / git-am.sh
CommitLineData
d1c5f2a4
JH
1#!/bin/sh
2#
d64e6b04 3# Copyright (c) 2005, 2006 Junio C Hamano
d1c5f2a4 4
c1491841 5SUBDIRECTORY_OK=Yes
78443d90
PH
6OPTIONS_KEEPDASHDASH=
7OPTIONS_SPEC="\
0adda936 8git am [options] [(<mbox>|<Maildir>)...]
09f8d055 9git am [options] (--resolved | --skip | --abort)
78443d90 10--
66006c63 11i,interactive run interactively
98ef23b3 12b,binary* (historical option -- no-op)
78443d90 133,3way allow fall back on 3way merging if needed
0e987a12 14q,quiet be quiet
78443d90
PH
15s,signoff add a Signed-off-by line to the commit message
16u,utf8 recode into utf8 (default)
fe1fa946 17k,keep pass -k flag to git-mailinfo
f7e5ea17 18keep-non-patch pass -b flag to git-mailinfo
ad2c9280 19keep-cr pass --keep-cr flag to git-mailsplit for mbox format
e80d4cbe 20no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
017678b4 21c,scissors strip everything before a scissors line
78443d90 22whitespace= pass it through git-apply
86c91f91
GB
23ignore-space-change pass it through git-apply
24ignore-whitespace pass it through git-apply
b47dfe9e 25directory= pass it through git-apply
77e9e496 26exclude= pass it through git-apply
58725efd 27include= pass it through git-apply
78443d90
PH
28C= pass it through git-apply
29p= pass it through git-apply
a5a6755a 30patch-format= format the patch(es) are in
b80da424 31reject pass it through git-apply
78443d90 32resolvemsg= override error message when patch failure occurs
c8089af6
JK
33continue continue applying patches after resolving a conflict
34r,resolved synonyms for --continue
3041c324 35skip skip the current patch
3e5057a8 36abort restore the original branch and abort the patching operation.
3f01ad66 37committer-date-is-author-date lie about committer date
a79ec62d 38ignore-date use current timestamp for author date
cb6020bb 39rerere-autoupdate update the index with reused conflict resolution if possible
98ef23b3 40rebasing* (internal use for git-rebase)"
78443d90 41
cf1fe88c 42. git-sh-setup
b9a97269 43. git-sh-i18n
bb034f83 44prefix=$(git rev-parse --show-prefix)
f9474132 45set_reflog_action am
7eff28a9 46require_work_tree
c1491841 47cd_to_toplevel
d1c5f2a4 48
460abee5 49git var GIT_COMMITTER_IDENT >/dev/null ||
79087259 50 die "$(gettext "You need to set your committer info first")"
d64e6b04 51
f79d4c8a
NS
52if git rev-parse --verify -q HEAD >/dev/null
53then
54 HAS_HEAD=yes
55else
56 HAS_HEAD=
57fi
58
d2c46310
RR
59cmdline="git am"
60if test '' != "$interactive"
61then
62 cmdline="$cmdline -i"
63fi
64if test '' != "$threeway"
65then
66 cmdline="$cmdline -3"
67fi
68
b47dfe9e 69sq () {
47c9739e 70 git rev-parse --sq-quote "$@"
b47dfe9e
JH
71}
72
d1c5f2a4
JH
73stop_here () {
74 echo "$1" >"$dotest/next"
7b3b7e37 75 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
d1c5f2a4
JH
76 exit 1
77}
78
7b3b7e37
JH
79safe_to_abort () {
80 if test -f "$dotest/dirtyindex"
81 then
82 return 1
83 fi
84
85 if ! test -s "$dotest/abort-safety"
86 then
87 return 0
88 fi
89
90 abort_safety=$(cat "$dotest/abort-safety")
91 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
92 then
93 return 0
94 fi
de88c1ce
JS
95 gettextln "You seem to have moved HEAD since the last 'am' failure.
96Not rewinding to ORIG_HEAD" >&2
7b3b7e37
JH
97 return 1
98}
99
ced9456a 100stop_here_user_resolve () {
cc120056 101 if [ -n "$resolvemsg" ]; then
a23bfaed 102 printf '%s\n' "$resolvemsg"
cc120056
SE
103 stop_here $1
104 fi
de88c1ce 105 eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
a4372c37 106If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
de88c1ce 107To restore the original branch and stop patching run \"\$cmdline --abort\"."
ced9456a
RS
108
109 stop_here $1
110}
111
d1c5f2a4
JH
112go_next () {
113 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
114 "$dotest/patch" "$dotest/info"
115 echo "$next" >"$dotest/next"
116 this=$next
117}
118
fd7bcfb5
JH
119cannot_fallback () {
120 echo "$1"
de88c1ce 121 gettextln "Cannot fall back to three-way merge."
fd7bcfb5
JH
122 exit 1
123}
124
d1c5f2a4
JH
125fall_back_3way () {
126 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
127
128 rm -fr "$dotest"/patch-merge-*
129 mkdir "$dotest/patch-merge-tmp-dir"
130
131 # First see if the patch records the index info that we can use.
4056afbc
JH
132 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
133 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
134 eval "$cmd" &&
fd7bcfb5 135 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
5be60078 136 git write-tree >"$dotest/patch-merge-base+" ||
a424ca15 137 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
fd7bcfb5 138
0e987a12 139 say Using index info to reconstruct a base tree...
4056afbc
JH
140
141 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
5d86861c
JH
142
143 if test -z "$GIT_QUIET"
144 then
145 eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
146 fi
147
4056afbc
JH
148 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
149 if eval "$cmd"
d1c5f2a4 150 then
d1c5f2a4
JH
151 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
152 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
fd7bcfb5 153 else
a424ca15
ÆAB
154 cannot_fallback "$(gettext "Did you hand edit your patch?
155It does not apply to blobs recorded in its index.")"
d1c5f2a4
JH
156 fi
157
158 test -f "$dotest/patch-merge-index" &&
5be60078 159 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
d1c5f2a4
JH
160 orig_tree=$(cat "$dotest/patch-merge-base") &&
161 rm -fr "$dotest"/patch-merge-* || exit 1
162
865207a6 163 say "$(gettext "Falling back to patching base and 3-way merge...")"
d1c5f2a4
JH
164
165 # This is not so wrong. Depending on which base we picked,
166 # orig_tree may be wildly different from ours, but his_tree
167 # has the same set of wildly different changes in parts the
579c9bb1 168 # patch did not touch, so recursive ends up canceling them,
d1c5f2a4
JH
169 # saying that we reverted all those changes.
170
2e6e3e82 171 eval GITHEAD_$his_tree='"$FIRSTLINE"'
579c9bb1 172 export GITHEAD_$his_tree
0e987a12
SB
173 if test -n "$GIT_QUIET"
174 then
69ae92bd 175 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
0e987a12 176 fi
579c9bb1 177 git-merge-recursive $orig_tree -- HEAD $his_tree || {
cb6020bb 178 git rerere $allow_rerere_autoupdate
d1c5f2a4
JH
179 echo Failed to merge in the changes.
180 exit 1
181 }
579c9bb1 182 unset GITHEAD_$his_tree
d1c5f2a4
JH
183}
184
0cd29a03
GB
185clean_abort () {
186 test $# = 0 || echo >&2 "$@"
187 rm -fr "$dotest"
188 exit 1
189}
190
a5a6755a
GB
191patch_format=
192
193check_patch_format () {
194 # early return if patch_format was set from the command line
195 if test -n "$patch_format"
196 then
197 return 0
198 fi
15ced753
GB
199
200 # we default to mbox format if input is from stdin and for
201 # directories
202 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
203 then
204 patch_format=mbox
205 return 0
206 fi
207
0e8341f2
DB
208 # otherwise, check the first few non-blank lines of the first
209 # patch to try to detect its format
15ced753 210 {
0e8341f2
DB
211 # Start from first line containing non-whitespace
212 l1=
213 while test -z "$l1"
214 do
f0c5793b 215 read l1 || break
0e8341f2 216 done
15ced753
GB
217 read l2
218 read l3
219 case "$l1" in
220 "From "* | "From: "*)
221 patch_format=mbox
222 ;;
223 '# This series applies on GIT commit'*)
224 patch_format=stgit-series
225 ;;
226 "# HG changeset patch")
227 patch_format=hg
228 ;;
229 *)
230 # if the second line is empty and the third is
231 # a From, Author or Date entry, this is very
232 # likely an StGIT patch
233 case "$l2,$l3" in
234 ,"From: "* | ,"Author: "* | ,"Date: "*)
235 patch_format=stgit
236 ;;
237 *)
238 ;;
239 esac
240 ;;
241 esac
0fcb2caf
JH
242 if test -z "$patch_format" &&
243 test -n "$l1" &&
244 test -n "$l2" &&
245 test -n "$l3"
246 then
247 # This begins with three non-empty lines. Is this a
248 # piece of e-mail a-la RFC2822? Grab all the headers,
249 # discarding the indented remainder of folded lines,
250 # and see if it looks like that they all begin with the
251 # header field names...
e3f67d30
SB
252 tr -d '\015' <"$1" |
253 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
e1622bfc 254 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
0fcb2caf
JH
255 patch_format=mbox
256 fi
0cd29a03 257 } < "$1" || clean_abort
a5a6755a
GB
258}
259
260split_patches () {
261 case "$patch_format" in
262 mbox)
e80d4cbe 263 if test -n "$rebasing" || test t = "$keepcr"
ad2c9280
SH
264 then
265 keep_cr=--keep-cr
266 else
267 keep_cr=
268 fi
c2ca1d79 269 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
0cd29a03 270 clean_abort
a5a6755a 271 ;;
c574e683
GB
272 stgit-series)
273 if test $# -ne 1
274 then
d62a1461 275 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
c574e683
GB
276 fi
277 series_dir=`dirname "$1"`
278 series_file="$1"
279 shift
280 {
281 set x
282 while read filename
283 do
284 set "$@" "$series_dir/$filename"
285 done
286 # remove the safety x
287 shift
288 # remove the arg coming from the first-line comment
289 shift
0cd29a03 290 } < "$series_file" || clean_abort
c574e683
GB
291 # set the patch format appropriately
292 patch_format=stgit
293 # now handle the actual StGIT patches
294 split_patches "$@"
295 ;;
296 stgit)
297 this=0
298 for stgit in "$@"
299 do
300 this=`expr "$this" + 1`
301 msgnum=`printf "%0${prec}d" $this`
302 # Perl version of StGIT parse_patch. The first nonemptyline
303 # not starting with Author, From or Date is the
304 # subject, and the body starts with the next nonempty
305 # line not starting with Author, From or Date
306 perl -ne 'BEGIN { $subject = 0 }
307 if ($subject > 1) { print ; }
308 elsif (/^\s+$/) { next ; }
45d51dc9 309 elsif (/^Author:/) { s/Author/From/ ; print ;}
c574e683
GB
310 elsif (/^(From|Date)/) { print ; }
311 elsif ($subject) {
312 $subject = 2 ;
313 print "\n" ;
314 print ;
315 } else {
316 print "Subject: ", $_ ;
317 $subject = 1;
318 }
0cd29a03 319 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
c574e683
GB
320 done
321 echo "$this" > "$dotest/last"
322 this=
323 msgnum=
324 ;;
0cfd1120
GB
325 hg)
326 this=0
327 for hg in "$@"
328 do
329 this=$(( $this + 1 ))
330 msgnum=$(printf "%0${prec}d" $this)
331 # hg stores changeset metadata in #-commented lines preceding
332 # the commit message and diff(s). The only metadata we care about
333 # are the User and Date (Node ID and Parent are hashes which are
334 # only relevant to the hg repository and thus not useful to us)
335 # Since we cannot guarantee that the commit message is in
336 # git-friendly format, we put no Subject: line and just consume
337 # all of the message as the body
338 perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
339 if ($subject) { print ; }
340 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
341 elsif (/^\# Date /) {
342 my ($hashsign, $str, $time, $tz) = split ;
343 $tz = sprintf "%+05d", (0-$tz)/36;
344 print "Date: " .
345 strftime("%a, %d %b %Y %H:%M:%S ",
346 localtime($time))
347 . "$tz\n";
348 } elsif (/^\# /) { next ; }
349 else {
350 print "\n", $_ ;
351 $subject = 1;
352 }
353 ' <"$hg" >"$dotest/$msgnum" || clean_abort
354 done
355 echo "$this" >"$dotest/last"
356 this=
357 msgnum=
358 ;;
a5a6755a 359 *)
dff4b0ef
GB
360 if test -n "$patch_format"
361 then
d62a1461 362 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
46caf505 363 else
d62a1461 364 clean_abort "$(gettext "Patch format detection failed.")"
46caf505 365 fi
a5a6755a
GB
366 ;;
367 esac
368}
369
d1c5f2a4 370prec=4
51ef1daa 371dotest="$GIT_DIR/rebase-apply"
ad2c9280 372sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
d25e5159 373resolvemsg= resume= scissors= no_inbody_headers=
67dad687 374git_apply_opt=
3f01ad66 375committer_date_is_author_date=
a79ec62d 376ignore_date=
cb6020bb 377allow_rerere_autoupdate=
d1c5f2a4 378
e80d4cbe
SH
379if test "$(git config --bool --get am.keepcr)" = true
380then
381 keepcr=t
382fi
383
822f7c73 384while test $# != 0
d1c5f2a4
JH
385do
386 case "$1" in
78443d90
PH
387 -i|--interactive)
388 interactive=t ;;
389 -b|--binary)
6c15a1c6
JH
390 echo >&2 "The $1 option has been a no-op for long time, and"
391 echo >&2 "it will be removed. Please do not use it anymore."
4eeb1de1 392 ;;
78443d90
PH
393 -3|--3way)
394 threeway=t ;;
dfdd7e66 395 -s|--signoff)
78443d90
PH
396 sign=t ;;
397 -u|--utf8)
398 utf8=t ;; # this is now default
399 --no-utf8)
400 utf8= ;;
401 -k|--keep)
402 keep=t ;;
f7e5ea17
TR
403 --keep-non-patch)
404 keep=b ;;
017678b4
JH
405 -c|--scissors)
406 scissors=t ;;
407 --no-scissors)
408 scissors=f ;;
c8089af6 409 -r|--resolved|--continue)
78443d90
PH
410 resolved=t ;;
411 --skip)
412 skip=t ;;
3e5057a8
NS
413 --abort)
414 abort=t ;;
3041c324 415 --rebasing)
d25e5159 416 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
78443d90 417 -d|--dotest)
79087259 418 die "$(gettext "-d option is no longer supported. Do not use.")"
e72c7406 419 ;;
78443d90
PH
420 --resolvemsg)
421 shift; resolvemsg=$1 ;;
58725efd 422 --whitespace|--directory|--exclude|--include)
b47dfe9e 423 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
78443d90 424 -C|-p)
b47dfe9e 425 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
a5a6755a
GB
426 --patch-format)
427 shift ; patch_format="$1" ;;
86c91f91 428 --reject|--ignore-whitespace|--ignore-space-change)
b80da424 429 git_apply_opt="$git_apply_opt $1" ;;
3f01ad66
JH
430 --committer-date-is-author-date)
431 committer_date_is_author_date=t ;;
a79ec62d
NS
432 --ignore-date)
433 ignore_date=t ;;
cb6020bb
JH
434 --rerere-autoupdate|--no-rerere-autoupdate)
435 allow_rerere_autoupdate="$1" ;;
0e987a12
SB
436 -q|--quiet)
437 GIT_QUIET=t ;;
ad2c9280
SH
438 --keep-cr)
439 keepcr=t ;;
e80d4cbe
SH
440 --no-keep-cr)
441 keepcr=f ;;
d1c5f2a4 442 --)
78443d90 443 shift; break ;;
d1c5f2a4 444 *)
78443d90 445 usage ;;
d1c5f2a4 446 esac
78443d90 447 shift
d1c5f2a4
JH
448done
449
0c15cc92
JH
450# If the dotest directory exists, but we have finished applying all the
451# patches in them, clear it out.
d1c5f2a4
JH
452if test -d "$dotest" &&
453 last=$(cat "$dotest/last") &&
454 next=$(cat "$dotest/next") &&
455 test $# != 0 &&
456 test "$next" -gt "$last"
457then
458 rm -fr "$dotest"
459fi
460
461if test -d "$dotest"
462then
3e5057a8 463 case "$#,$skip$resolved$abort" in
c95b1389
JH
464 0,*t*)
465 # Explicit resume command and we do not have file, so
466 # we are happy.
467 : ;;
468 0,)
469 # No file input but without resume parameters; catch
470 # user error to feed us a patch from standard input
e72c7406 471 # when there is already $dotest. This is somewhat
c95b1389
JH
472 # unreliable -- stdin could be /dev/null for example
473 # and the caller did not intend to feed us a patch but
474 # wanted to continue unattended.
98ef23b3 475 test -t 0
c95b1389
JH
476 ;;
477 *)
478 false
479 ;;
480 esac ||
79087259 481 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
271440e3 482 resume=yes
3e5057a8 483
95f8ebbf 484 case "$skip,$abort" in
2d56a136 485 t,t)
79087259 486 die "$(gettext "Please make up your mind. --skip or --abort?")"
2d56a136 487 ;;
95f8ebbf
OM
488 t,)
489 git rerere clear
490 git read-tree --reset -u HEAD HEAD
491 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
492 git reset HEAD
493 git update-ref ORIG_HEAD $orig_head
494 ;;
495 ,t)
2d56a136
JH
496 if test -f "$dotest/rebasing"
497 then
498 exec git rebase --abort
499 fi
3e5057a8 500 git rerere clear
7b3b7e37
JH
501 if safe_to_abort
502 then
c767184d
MG
503 git read-tree --reset -u HEAD ORIG_HEAD
504 git reset ORIG_HEAD
7b3b7e37 505 fi
3e5057a8
NS
506 rm -fr "$dotest"
507 exit ;;
508 esac
c767184d 509 rm -f "$dotest/dirtyindex"
d1c5f2a4 510else
3e5057a8
NS
511 # Make sure we are not given --skip, --resolved, nor --abort
512 test "$skip$resolved$abort" = "" ||
79087259 513 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
d1c5f2a4
JH
514
515 # Start afresh.
516 mkdir -p "$dotest" || exit
517
bb034f83
JH
518 if test -n "$prefix" && test $# != 0
519 then
520 first=t
521 for arg
522 do
523 test -n "$first" && {
524 set x
525 first=
526 }
5e9677cb
PT
527 if is_absolute_path "$arg"
528 then
529 set "$@" "$arg"
530 else
531 set "$@" "$prefix$arg"
532 fi
bb034f83
JH
533 done
534 shift
535 fi
a5a6755a
GB
536
537 check_patch_format "$@"
538
539 split_patches "$@"
d1c5f2a4 540
017678b4
JH
541 # -i can and must be given when resuming; everything
542 # else is kept
9b9f5a22 543 echo " $git_apply_opt" >"$dotest/apply-opt"
22db240d 544 echo "$threeway" >"$dotest/threeway"
d1c5f2a4
JH
545 echo "$sign" >"$dotest/sign"
546 echo "$utf8" >"$dotest/utf8"
547 echo "$keep" >"$dotest/keep"
017678b4 548 echo "$scissors" >"$dotest/scissors"
d25e5159 549 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
0e987a12 550 echo "$GIT_QUIET" >"$dotest/quiet"
d1c5f2a4 551 echo 1 >"$dotest/next"
3041c324
JH
552 if test -n "$rebasing"
553 then
554 : >"$dotest/rebasing"
555 else
556 : >"$dotest/applying"
f79d4c8a
NS
557 if test -n "$HAS_HEAD"
558 then
559 git update-ref ORIG_HEAD HEAD
560 else
561 git update-ref -d ORIG_HEAD >/dev/null 2>&1
562 fi
3041c324 563 fi
d1c5f2a4
JH
564fi
565
2a6f08ac
JK
566git update-index -q --refresh
567
0c15cc92
JH
568case "$resolved" in
569'')
f79d4c8a
NS
570 case "$HAS_HEAD" in
571 '')
572 files=$(git ls-files) ;;
573 ?*)
574 files=$(git diff-index --cached --name-only HEAD --) ;;
575 esac || exit
c767184d
MG
576 if test "$files"
577 then
f79d4c8a 578 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
79087259 579 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
c767184d 580 fi
0c15cc92
JH
581esac
582
f7e5ea17
TR
583# Now, decide what command line options we will give to the git
584# commands we invoke, based on the result of parsing command line
585# options and previous invocation state stored in $dotest/ files.
586
d1c5f2a4
JH
587if test "$(cat "$dotest/utf8")" = t
588then
589 utf8=-u
bb1091a4
JH
590else
591 utf8=-n
d1c5f2a4 592fi
f7e5ea17
TR
593keep=$(cat "$dotest/keep")
594case "$keep" in
595t)
596 keep=-k ;;
597b)
598 keep=-b ;;
599*)
600 keep= ;;
601esac
017678b4
JH
602case "$(cat "$dotest/scissors")" in
603t)
604 scissors=--scissors ;;
605f)
606 scissors=--no-scissors ;;
607esac
d25e5159
LS
608if test "$(cat "$dotest/no_inbody_headers")" = t
609then
610 no_inbody_headers=--no-inbody-headers
611else
612 no_inbody_headers=
613fi
0e987a12
SB
614if test "$(cat "$dotest/quiet")" = t
615then
616 GIT_QUIET=t
617fi
22db240d
JH
618if test "$(cat "$dotest/threeway")" = t
619then
620 threeway=t
621fi
9b9f5a22 622git_apply_opt=$(cat "$dotest/apply-opt")
d1c5f2a4
JH
623if test "$(cat "$dotest/sign")" = t
624then
5354a56f 625 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
d1c5f2a4
JH
626 s/>.*/>/
627 s/^/Signed-off-by: /'
628 `
629else
630 SIGNOFF=
631fi
d1c5f2a4
JH
632
633last=`cat "$dotest/last"`
634this=`cat "$dotest/next"`
635if test "$skip" = t
636then
637 this=`expr "$this" + 1`
69224716 638 resume=
d1c5f2a4
JH
639fi
640
d1c5f2a4
JH
641while test "$this" -le "$last"
642do
643 msgnum=`printf "%0${prec}d" $this`
644 next=`expr "$this" + 1`
645 test -f "$dotest/$msgnum" || {
69224716 646 resume=
d1c5f2a4
JH
647 go_next
648 continue
649 }
0c15cc92
JH
650
651 # If we are not resuming, parse and extract the patch information
652 # into separate files:
653 # - info records the authorship and title
654 # - msg is the rest of commit log message
655 # - patch is the patch body.
656 #
657 # When we are resuming, these files are either already prepared
658 # by the user, or the user can tell us to do so by --resolved flag.
271440e3
JH
659 case "$resume" in
660 '')
d25e5159 661 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
271440e3
JH
662 <"$dotest/$msgnum" >"$dotest/info" ||
663 stop_here $this
ca193cf1
JS
664
665 # skip pine's internal folder data
e1622bfc 666 sane_grep '^Author: Mail System Internal Data$' \
ca193cf1
JS
667 <"$dotest"/info >/dev/null &&
668 go_next && continue
669
28ed6e7b 670 test -s "$dotest/patch" || {
de88c1ce 671 eval_gettextln "Patch is empty. Was it split wrong?
a4372c37 672If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
de88c1ce 673To restore the original branch and stop patching run \"\$cmdline --abort\"."
87ab7992
DZ
674 stop_here $this
675 }
43c23251 676 rm -f "$dotest/original-commit" "$dotest/author-script"
5e835cac
JH
677 if test -f "$dotest/rebasing" &&
678 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
679 -e q "$dotest/$msgnum") &&
680 test "$(git cat-file -t "$commit")" = commit
681 then
682 git cat-file commit "$commit" |
683 sed -e '1,/^$/d' >"$dotest/msg-clean"
96e19488 684 echo "$commit" > "$dotest/original-commit"
43c23251 685 get_author_ident_from_commit "$commit" > "$dotest/author-script"
5e835cac 686 else
c970a6fd
JH
687 {
688 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
689 echo
690 cat "$dotest/msg"
691 } |
692 git stripspace > "$dotest/msg-clean"
5e835cac 693 fi
271440e3
JH
694 ;;
695 esac
d1c5f2a4 696
43c23251
JS
697 if test -f "$dotest/author-script"
698 then
699 eval $(cat "$dotest/author-script")
700 else
701 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
702 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
703 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
704 fi
e0e3ba20 705
3b78959e 706 if test -z "$GIT_AUTHOR_EMAIL"
e0e3ba20 707 then
de88c1ce 708 gettextln "Patch does not have a valid e-mail address."
e0e3ba20
JH
709 stop_here $this
710 fi
711
2c674191 712 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
d1c5f2a4 713
4bfb6b62
JH
714 case "$resume" in
715 '')
716 if test '' != "$SIGNOFF"
717 then
d1c5f2a4 718 LAST_SIGNED_OFF_BY=`
4bfb6b62
JH
719 sed -ne '/^Signed-off-by: /p' \
720 "$dotest/msg-clean" |
b4ce54fc 721 sed -ne '$p'
d1c5f2a4 722 `
4bfb6b62
JH
723 ADD_SIGNOFF=`
724 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
d1c5f2a4
JH
725 test '' = "$LAST_SIGNED_OFF_BY" && echo
726 echo "$SIGNOFF"
4bfb6b62
JH
727 }`
728 else
d1c5f2a4 729 ADD_SIGNOFF=
4bfb6b62
JH
730 fi
731 {
d1c5f2a4
JH
732 if test -s "$dotest/msg-clean"
733 then
d1c5f2a4
JH
734 cat "$dotest/msg-clean"
735 fi
736 if test '' != "$ADD_SIGNOFF"
737 then
738 echo "$ADD_SIGNOFF"
739 fi
4bfb6b62
JH
740 } >"$dotest/final-commit"
741 ;;
0c15cc92 742 *)
6d28644d 743 case "$resolved$interactive" in
0c15cc92
JH
744 tt)
745 # This is used only for interactive view option.
38762c47 746 git diff-index -p --cached HEAD -- >"$dotest/patch"
0c15cc92
JH
747 ;;
748 esac
4bfb6b62 749 esac
d1c5f2a4 750
4bfb6b62 751 resume=
d1c5f2a4
JH
752 if test "$interactive" = t
753 then
a1451104 754 test -t 0 ||
79087259 755 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
d1c5f2a4
JH
756 action=again
757 while test "$action" = again
758 do
de88c1ce 759 gettextln "Commit Body is:"
d1c5f2a4
JH
760 echo "--------------------------"
761 cat "$dotest/final-commit"
762 echo "--------------------------"
7a74d04a
ÆAB
763 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
764 # in your translation. The program will only accept English
765 # input at this point.
766 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
d1c5f2a4
JH
767 read reply
768 case "$reply" in
f89ad67f
JH
769 [yY]*) action=yes ;;
770 [aA]*) action=yes interactive= ;;
771 [nN]*) action=skip ;;
ef0c2abf 772 [eE]*) git_editor "$dotest/final-commit"
d1c5f2a4 773 action=again ;;
f89ad67f 774 [vV]*) action=again
f6dff119 775 git_pager "$dotest/patch" ;;
f89ad67f 776 *) action=again ;;
d1c5f2a4
JH
777 esac
778 done
779 else
780 action=yes
781 fi
92f65e6a
RR
782
783 if test -f "$dotest/final-commit"
784 then
785 FIRSTLINE=$(sed 1q "$dotest/final-commit")
786 else
787 FIRSTLINE=""
788 fi
d1c5f2a4
JH
789
790 if test $action = skip
791 then
792 go_next
793 continue
794 fi
795
796 if test -x "$GIT_DIR"/hooks/applypatch-msg
797 then
798 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
799 stop_here $this
800 fi
801
dff1a983 802 say "$(eval_gettext "Applying: \$FIRSTLINE")"
d1c5f2a4 803
0c15cc92
JH
804 case "$resolved" in
805 '')
3ddd1703
SB
806 # When we are allowed to fall back to 3-way later, don't give
807 # false errors during the initial attempt.
808 squelch=
809 if test "$threeway" = t
810 then
811 squelch='>/dev/null 2>&1 '
812 fi
813 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
0c15cc92
JH
814 apply_status=$?
815 ;;
816 t)
817 # Resolved means the user did all the hard work, and
818 # we do not have to do any patch application. Just
819 # trust what the user has in the index file and the
820 # working tree.
821 resolved=
38762c47 822 git diff-index --quiet --cached HEAD -- && {
de88c1ce 823 gettextln "No changes - did you forget to use 'git add'?
bd8643ae 824If there is nothing left to stage, chances are that something else
de88c1ce 825already introduced the same changes; you might want to skip this patch."
ced9456a 826 stop_here_user_resolve $this
06aff47b 827 }
5be60078 828 unmerged=$(git ls-files -u)
c1d1128b
JH
829 if test -n "$unmerged"
830 then
de88c1ce
JS
831 gettextln "You still have unmerged paths in your index
832did you forget to use 'git add'?"
ced9456a 833 stop_here_user_resolve $this
c1d1128b 834 fi
0c15cc92 835 apply_status=0
b4372ef1 836 git rerere
0c15cc92
JH
837 ;;
838 esac
839
0ba17dd0 840 if test $apply_status != 0 && test "$threeway" = t
d1c5f2a4 841 then
73319032 842 if (fall_back_3way)
d1c5f2a4 843 then
73319032
JH
844 # Applying the patch to an earlier tree and merging the
845 # result may have produced the same tree as ours.
38762c47 846 git diff-index --quiet --cached HEAD -- && {
dff1a983 847 say "$(gettext "No changes -- Patch already applied.")"
06aff47b
AR
848 go_next
849 continue
850 }
73319032
JH
851 # clear apply_status -- we have successfully merged.
852 apply_status=0
d1c5f2a4
JH
853 fi
854 fi
855 if test $apply_status != 0
856 then
de88c1ce 857 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
14bf2d58
PG
858 if test "$(git config --bool advice.amworkdir)" != false
859 then
860 eval_gettextln "The copy of the patch that failed is found in:
861 $dotest/patch"
862 fi
ced9456a 863 stop_here_user_resolve $this
d1c5f2a4
JH
864 fi
865
866 if test -x "$GIT_DIR"/hooks/pre-applypatch
867 then
868 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
869 fi
870
5be60078 871 tree=$(git write-tree) &&
3f01ad66 872 commit=$(
a79ec62d
NS
873 if test -n "$ignore_date"
874 then
875 GIT_AUTHOR_DATE=
876 fi
f79d4c8a 877 parent=$(git rev-parse --verify -q HEAD) ||
dff1a983 878 say >&2 "$(gettext "applying to an empty history")"
f79d4c8a 879
3f01ad66
JH
880 if test -n "$committer_date_is_author_date"
881 then
882 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
883 export GIT_COMMITTER_DATE
884 fi &&
ea10b60c 885 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
3f01ad66 886 ) &&
2e6e3e82 887 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
d1c5f2a4
JH
888 stop_here $this
889
96e19488
TR
890 if test -f "$dotest/original-commit"; then
891 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
892 fi
893
d1c5f2a4
JH
894 if test -x "$GIT_DIR"/hooks/post-applypatch
895 then
896 "$GIT_DIR"/hooks/post-applypatch
897 fi
898
899 go_next
900done
901
eb2151bb
TR
902if test -s "$dotest"/rewritten; then
903 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
904 if test -x "$GIT_DIR"/hooks/post-rewrite; then
96e19488 905 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
eb2151bb 906 fi
96e19488
TR
907fi
908
d1c5f2a4 909rm -fr "$dotest"
29b67543 910git gc --auto